function love.load()
	love.graphics.setBackgroundColor(174, 168, 162)
	love.graphics.setFont(love.graphics.newFont("/resources/fonts/BonvenoCF-Light.otf", 20))
	
	img = {}
	img.overlay = love.graphics.newImage("/resources/images/overlay.png")
	
	player = {
		y = 450,
		yVelocity = 0,
		yDouble = false,
	}
	
	properties = {
		gravity = 800,
		jumpHeight = -400,
	}
	
	map = {{0, 0, 800}, {0, 200, 100}, {0, 200, 100}}
	
	px = 0
	speed = 1
	
end

function love.update(dt)
	if player.yVelocity ~= 0 then
		player.y = player.y + player.yVelocity * dt
		
		player.yVelocity = player.yVelocity + properties.gravity * dt
		if player.y > 450 then
			player.yVelocity = 0
			player.y = 450
			player.yDouble = false
		end
	end
	
	speed = speed + 0.1 * dt
	px = px - 1 * dt * 150 * speed
end

function love.draw()
	-- Draw Overlay --
	love.graphics.setColor(238, 102, 60)
	love.graphics.rectangle("fill", 300, player.y, 50, 50)
	
	-- Draw Terrain --
	love.graphics.setColor(51, 51, 51)
	preW = 0
	preX = 0
	for i, tbl in ipairs(map) do	
		local newtbl = {preX + preW + tbl[2], tbl[2], tbl[3]}
		if act then
			error(newtbl[1] + px)
		
		end
		love.graphics.rectangle("fill", newtbl[1] + px, 500, newtbl[3], 100)
		map[i] = newtbl
		preW = newtbl[3]
		preX = newtbl[1]
	end

	for i, tbl in ipairs(map) do
		if tbl[1] + tbl[3] + px < 0 then
			table.remove(map, i)
			act = true
		end
	end
	
	love.graphics.setColor(255, 255, 255)
	love.graphics.setBlendMode("multiplicative")
	love.graphics.draw(img.overlay, 0, 0)
	love.graphics.setBlendMode("alpha")
	love.graphics.print(px, 10, 10)
end

function love.keypressed(key)
	if key == " " then
		if not player.yDouble and player.y ~= 450 then
			player.yVelocity = properties.jumpHeight
			player.yDouble = true
		end
		
		if player.yVelocity == 0 then
			player.yVelocity = properties.jumpHeight
		end
	end
end